#!/usr/bin/env python
# -*- coding: utf-8 -*-
"""
    demeter load
    author:rabin
"""
from demeter.web.base import *

class Load(Base):
	KEYS = ('farm', 'admin')

	def setting(self):
		self.admin()

	def admin(self):
		admin = 1
		self.data['auth'] = True
		
		if 'admin' in Demeter.config['setting'] and Demeter.config['setting']['admin'] > 0:
			if 'adminInfo' not in Demeter.config['setting'] or ('adminInfo' in Demeter.config['setting'] and Demeter.config['setting']['admin'] != Demeter.config['setting']['adminInfo']):
				Demeter.config['setting']['adminInfo'] = self.service('common').one('manage_admin', id=Demeter.config['setting']['admin'])
				if Demeter.config['setting']['adminInfo']:
					Demeter.config['setting']['roleInfo'] = self.service('common').one('manage_role', id=Demeter.config['setting']['adminInfo']['role_id'])
		else:
			#self.redirect('/user/login')
			return

		if 'farm' in Demeter.config['setting'] and Demeter.config['setting']['farm'] > 0:
			if 'farmInfo' not in Demeter.config['setting'] or ('farmInfo' in Demeter.config['setting'] and Demeter.config['setting']['farm'] != Demeter.config['setting']['farmInfo']):
				Demeter.config['setting']['farmInfo'] = self.service('common').one('farm', id=Demeter.config['setting']['farm'])
				if not Demeter.config['setting']['farmInfo']:
					Demeter.config['setting']['farmInfo']['name'] = '默认'

		if 'menuList' not in Demeter.config['setting']:
			Demeter.config['setting']['menuList'] = self.menu()

		if Demeter.config['setting']['adminInfo']['id'] == admin:
			if 'menu' in Demeter.config['setting']:
				del Demeter.config['setting']['menu']
		else:
			if 'menu' not in Demeter.config['setting'] and 'roleInfo' in Demeter.config['setting']:
				Demeter.config['setting']['menu'] = ['_/', '_/login', '_/main', '_/admin/log_update']
				menu = Demeter.config['setting']['roleInfo']['auth'] + ','
				for i,j in enumerate(Demeter.config['setting']['menuList'][1]):
					m = 0
					for n in j[0]:
						if n+',' in menu:
							l = str(i)+'_'+str(n)
							Demeter.config['setting']['menu'].append(l)
							Demeter.config['setting']['menu'].append(l + '_update')
						m = m + 1
				Demeter.config['setting']['menu'] = ',' + ",".join(Demeter.config['setting']['menu'])+','

			uri = '_' + self.request.uri + ','
			if Demeter.config['setting']['admin'] != admin and uri not in Demeter.config['setting']['menu']:
				self.data['auth'] = False

		if 'farmList' not in Demeter.config['setting']:
			Demeter.config['setting']['farmList'] = self.service('common').list('farm')

	def menu(self):
		parent = [['农场与设备管理', '网站管理', '基础设置'],['&#xe62e;', '&#xe62a;', '&#xe614;']]
		child = [
			[['/farm/farm','/device/gateway','/device/info','/work/work','/work/category','/work/land','/origin/batch','/farm/user','/device/printer','/msg/msg'],['农场列表', '网关管理', '设备管理', '农场农事管理', '农场农事方式', '农场地块管理', '溯源批次管理','农场用户管理','农场打印机','消息提醒']]
			,[['/content/info','/content/article','/content/category', '/content/set', '/sms/sms'],['首页内容管理', '文章管理', '文章分类', '网站基础设置', '短信通知']]
			,[['/device/type','/hardware/type','/msg/type','/admin/admin','/admin/role','/hardware/hardware', '/admin/log'],['设备类型管理','硬件类型管理', '消息类型设置', '管理员设置', '管理权限设置','硬件设备记录', '系统日志']]
			]
		return (parent,child)
